﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using IronPython.Hosting;
using Microsoft.Scripting.Hosting;
using DesktopStation;

namespace DSPython
{
    public partial class MainForm : Form
    {
        private DSScriptEngine engine;
        private DSRemoteClient ipcClient;


        public MainForm()
        {
            InitializeComponent();

            engine = new DSScriptEngine(sendCommand);
            ipcClient = new DSRemoteClient();
        }

        /* Desktop Stationへ指令を送信 */
        private void sendCommand(String inCommand)
        {
            ipcClient.SendData(inCommand);

        }

        private void button1_Click(object sender, EventArgs e)
        {
            
        }

        private void timerInterval_Tick(object sender, EventArgs e)
        {
            /* タスクを生成する */

            if (engine.IsRunning() == false)
            {
                return;
            }

            
            /* 50ms周期 */
            engine.RunTask(1);

        }


        private void buttonClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {

            if (engine.IsRunning() == false)
            {
                if (engine.Start())
                {
                    (sender as ToolStripButton).Text = "Stop";
                    timerInterval.Enabled = true;
                    statusLabel_Status.Text = "Processing";
                }
            }
            else
            {
                engine.Stop();
                (sender as ToolStripButton).Text = "Start";
                timerInterval.Enabled = false;
                statusLabel_Status.Text = "Waiting for start";
            }
        }

        private void buttonOpenScript_Click(object sender, EventArgs e)
        {
            OpenFileDialog aForm = new OpenFileDialog();
            aForm.CheckFileExists = true;
            aForm.Filter = "Python file(*.py)|*.py|All files(*.*)|*.*";

            //押されたボタン別の処理 
            if (aForm.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                openScriptFile(aForm.FileName);
            }

            aForm.Dispose();
        }

        private void openScriptFile(String inFilename)
        {
            if (File.Exists(inFilename) == false)
            {
                return;
            }

            richTextBox.LoadFile(inFilename, RichTextBoxStreamType.PlainText);
            engine.LoadFromScript(richTextBox.Text);
        }

    }
}
